;**********************************************************************
;   This file is a basic code template for assembly code generation   *
;   on the PICmicro PIC16F84. This file contains the basic code       *
;   building blocks to build upon.                                    *  
;                                                                     *
;   If interrupts are not used all code presented between the ORG     *
;   0x004 directive and the label main can be removed. In addition    *
;   the variable assignments for 'w_temp' and 'status_temp' can       *
;   be removed.                                                       *                        
;                                                                     *
;   Refer to the MPASM User's Guide for additional information on     *
;   features of the assembler (Document DS33014).                     *
;                                                                     *
;   Refer to the respective PICmicro data sheet for additional        *
;   information on the instruction set.                               *
;                                                                     *
;   Template file assembled with MPLAB V3.99.18 and MPASM V2.15.06.   *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Filename:     -21213	      *
;    Date: 20.04.04.                                                  *
;    File Version:                                                    *
;                                                                     *
;    Author:  ..                                            *
;    Company:                                                         *
;                                                                     * 
;                                                                     *
;**********************************************************************
;                                                                     *
;    Files required:                                                  *
;                                                                     *
;                                                                     *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Notes:                                                           *
;                                                                     *
;                                                                     *
;                                                                     *
;                                                                     *
;**********************************************************************


	list      p=16F84             ; list directive to define processor
	#include <p16F84.inc>         ; processor specific variable definitions

	__CONFIG   _CP_OFF & _WDT_ON & _PWRTE_ON & _XT_OSC

; '__CONFIG' directive is used to embed configuration data within .asm file.
; The lables following the directive are located in the respective .inc file.
; See respective data sheet for additional information on configuration word.




;***** VARIABLE DEFINITIONS
counth        EQU     H'0E'       ;   
countl        EQU     H'0F'       ;   







;**********************************************************************
		ORG     0x000             ; processor reset vector
  		goto    main              ; go to beginning of program


		ORG     0x004             ; interrupt vector location
		goto    main
main:   clrwdt                        ;   
        clrw
start:  bsf  3,5
        movlw  b'00000001'
        movwf  H'6'
        movlw  b'00000000'
        movwf  H'5'
        bcf  3,5                      ;   RB1  , RB0   
wait:   bcf    6,1                    ;  RB1=0
        clrwdt                        ;     RB0,  =0   sostRB0 
        btfsc  6,0
        goto   wait
sostRB0: clrwdt                       ;
        btfss  6,0                    ;   RB0, =1
        goto   sostRB0                ;  
        bcf    6,1                    ;  RB1=0
        clrf   countl                 ;   =0
        clrf   counth                 ;   =0
        clrw
inc:    btfss  6,0                    ;  RB0--------
        goto   dec                    ;---- ----
        clrwdt
        incfsz countl,1               ;--  . 1
        goto   inc                    ;  .  0-------
        incf   counth,1               ;---  .  1
        clrwdt                        ;  
        movlw  6                      ; . =6  ---
        xorwf  counth,0               ;-- wait-------N < 1200 \
        btfsc  3,2                    ;------
        goto   wait                   ; 
        goto   inc                    ; 
dec:    movlw  0                      ; . =0  ---
        xorwf  counth,0               ;--- sostRB0,     6000 \
        btfsc  3,2                    ; 
        goto   sostRB0                ;
        movlw  1                      ;    2800 -- 
        xorwf  counth,0               ;---- dec1 
        btfsc  3,2                    ;    2800 --
        goto   dec2                   ;--- dec2
        movlw  H'2'                   ; 
        xorwf  counth,0               ; 
        btfss  3,2                    ; 
        goto   dec1                   ; 
        movlw  H'53'                  ; 
        subwf  countl,0               ; 
        btfss  3,0                    ;
        goto   dec2                   ; 
dec1:   movlw  H'6E'                  ;    2800-------
        subwf  countl,1               ;----   --
        btfss  3,0                    ;-- 110()
        decf   counth,1               ;
        movlw  0
        xorwf  countl,0
        btfsc  3,2
        goto   dec111
dec11:  clrwdt                        ;   ----
        btfsc 6,0                           ;---  =13mcs --
        goto sostRB0                           ;--   "nop"--
        nop                           ;--   
        nop                           ;
        nop                           ;
        nop                           ;
        nop
        nop
        nop                           ;
        decfsz countl,1               ;
        goto   dec11                  ;
dec111: clrwdt                        ;   ---
        btfsc 6,0                           ;--  =13mcs ---
        goto sostRB0                           ;--   "nop"--
        nop                           ;--   
        nop                           ;
        nop
        nop
        nop                           ;
        nop                           ;
        nop                           ;
        decfsz countl,1               ;
        goto   dec111                 ;  =0---
        decfsz counth,1               ;-- RB1=1---
        goto   dec111                 ;--   --
        bsf    6,1                    ;--sostRB0
        goto   sostRB0                ;
dec2:   movlw  H'41'                  ;     ---
        subwf  countl,1               ;-- 65()
        btfss  3,0                    ; 
        decf   counth,1               ;
        movlw  0
        xorwf  countl,0
        btfsc  3,2
        goto   dec222 
dec22:  clrwdt                        ;   ---
        btfsc 6,0                           ;---  =12mcs  ---
        goto sostRB0                           ;--   "nop" --
        nop                           ;--  
        nop                           ;
        nop
        nop
        nop                           ;
        nop                           ;
        decfsz countl,1               ;
        goto   dec22                  ;
        movlw  0                      ;
        xorwf  counth,0               ;
        btfsc  3,2                    ;
        goto   dec333                ;
dec222: clrwdt                        ;   ---
        btfsc 6,0                           ;-- =12mcs  ---
        goto sostRB0                           ;---   "nop" ---
        nop                           ;---  
        nop                           ;
        nop
        nop
        nop                           ;
        nop                           ;
        decfsz countl,1               ;
        goto   dec222                 ;  =0---
        decfsz counth,1               ;--- RB1=1---
        goto   dec222                 ;--   ---
dec333: bsf    6,1                    ;--sostRB0
        clrwdt
        goto   sostRB0                ;
; remaining code goes here










		END                     ; directive 'end of program'

